using UnityEngine;
using System.Collections;

public class Menu : MonoBehaviour
{
	
	public static Menu SP;
	public Texture2D connectButton;
	public Texture2D playButtonWii;
	public Texture2D playButtonMind;
	public Texture2D returnButton;
	public Texture2D statusBar;
	public Texture2D logo;
	public Texture2D on;
	public Texture2D off;
	public Texture2D cursor;
	public Texture2D cursorshot;
	public Texture2D attentionFull;
	public Texture2D attentionEmpty;
	public GUIStyle nullstyle;
	public Transform menuPlane;
	public Transform planeSpawnpoint;
	public Transform paperPlane;
	public bool wiiMoteConnection = false;
	public bool thinkGearConnection = false;
	public string portName = "COM3";
	public Vector2 Wii_Screenpos;
	public bool Wii_A;
	public float attention;
	bool startAnim = false;
	bool connectAttempt = false;
	bool Shot = false;
	public int score = 0;
	public int Highscore = 0;
	public int bullets = 0;
	public AudioClip click;
	float showattent = 0;
	
	public bool WiiMove;
	
	public enum GameState
	{
		menu,
		game,
		gameOver
	};
	
	public GameState gameState = GameState.menu;
	

	// Use this for initialization
	void Start ()
	{
		SP = this;
		 
	}
	
	void ResetConnectAttempt ()
	{
		connectAttempt = false;
		
	}
	
	void OnGUI ()
	{
		if (gameState == GameState.menu) {
			GUI.DrawTexture (DrawCenter (5, logo), logo);
			
			if (!startAnim)
				DrawShadowText (new Rect (Screen.width / 2 - 50, Screen.height / 2, 1000, 100), "Highscore: " + Highscore);
			
			if (!startAnim && (GUI.Button (DrawCenter ((int)(0.55f * Screen.height), playButtonWii), playButtonWii, nullstyle) || (DrawCenter ((int)(0.55f * Screen.height), playButtonWii).Contains (Wii_Screenpos)) && UniWiiCheck.SP.wiiButton_A ())) {
				WiiMove = true;
				bullets = 5;
				score = 0;
				startAnim = true;
				audio.PlayOneShot (click);
				menuPlane.animation.Play ("start");
				Invoke ("StartGame", 1);
				CleanUp();

			}
			if (!startAnim && (GUI.Button (DrawCenter ((int)(0.70f * Screen.height), playButtonMind), playButtonMind, nullstyle) || (DrawCenter ((int)(0.70f * Screen.height), playButtonMind).Contains (Wii_Screenpos)) && UniWiiCheck.SP.wiiButton_A ())) {
				bullets = 5;
				score = 0;
				startAnim = true;
				audio.PlayOneShot (click);
				menuPlane.animation.Play ("start");
				Invoke ("StartGame", 1);
				CleanUp ();

			}

			
			//if (!connectAttempt && !startAnim && (GUI.Button (DrawCenter ((int)(0.80f * Screen.height), connectButton), connectButton, nullstyle) || (DrawCenter ((int)(0.73f * Screen.height), connectButton).Contains (Wii_Screenpos)) && UniWiiCheck.SP.wiiButton_A ())) {
			//	connectAttempt = true;
			//	audio.PlayOneShot (click);
				//SendMessage("OnHeadsetConnectionRequest", portName);
			//	Invoke ("ResetConnectAttempt", 0.3f);
		//	}
			

			
			if (!startAnim) {
				GUI.DrawTexture (DrawCenter (Screen.height - statusBar.height, statusBar), statusBar);
				if (wiiMoteConnection)
					GUI.DrawTexture (new Rect ((Screen.width / 2) + 125, Screen.height - 67, on.width, on.height), on);
				else
					GUI.DrawTexture (new Rect ((Screen.width / 2) + 125, Screen.height - 65, off.width, off.height), off);
			
				if (ThinkGearController.SP.connected) {
					bool thinkGearConnection = true;
					GUI.DrawTexture (new Rect ((Screen.width / 2) + 125, Screen.height - 27, on.width, on.height), on);
				} else
					GUI.DrawTexture (new Rect ((Screen.width / 2) + 125, Screen.height - 25, off.width, off.height), off);
			}
		} else if (gameState == GameState.game) {
			
			if(WiiMove)
				DrawShadowText (new Rect ( Screen.width- 200,5, 1000, 100), "Gamespeed: " + Time.timeScale.ToString("F1") +"x");

			DrawShadowText (new Rect (5, 5, 1000, 100), "Score: " + score);	
			DrawShadowText (new Rect (5, 25, 1000, 100), "Highscore: " + Highscore);	
			
			if (wiiMoteConnection && !WiiMove)
				DrawShadowText (new Rect (5, 75, 1000, 100), "Bullets: " + bullets);	
			showattent = Mathf.Lerp (showattent, attention, Time.deltaTime * 2);
			GUI.DrawTexture (new Rect (5, Screen.height - 5 - attentionFull.height, attentionFull.width, attentionFull.height), attentionEmpty);
			GUI.DrawTextureWithTexCoords (new Rect (5, Screen.height - 5 - attentionFull.height, attentionFull.width * showattent, attentionFull.height), attentionFull, new Rect (0, 0, showattent, 1));

			
		} else if (gameState == GameState.gameOver) {
			if (!Music.SP.isitPlayint())
				Music.SP.StartMusic();
			DrawShadowText (new Rect (Screen.width / 2 - 50, Screen.height / 2, 1000, 100), "Your score: " + score);	

			if (score > Highscore) {
				DrawShadowText (new Rect (Screen.width / 2 - 70, Screen.height / 2 + 50, 1000, 100), "New Highscore!");	
			}
		
			
			if ((GUI.Button (DrawCenter ((int)(0.84f * Screen.height), returnButton), returnButton, nullstyle) || (DrawCenter ((int)(0.84f * Screen.height), returnButton).Contains (Wii_Screenpos)) && UniWiiCheck.SP.wiiButton_A ())) {
				menuPlane.animation.Rewind ();
							Music.SP.StartMusic();		

				CleanUp ();
				Highscore = score;
				audio.PlayOneShot (click);
				connectAttempt = false; 
				startAnim = false;

				gameState = GameState.menu;

				
			}
			
		}
		if(!WiiMove)
		{
		if (Shot == true)
			GUI.DrawTexture (new Rect (Wii_Screenpos.x - cursor.width / 2, Wii_Screenpos.y - cursorshot.height / 2, cursorshot.width, cursorshot.height), cursorshot);
		
		GUI.DrawTexture (new Rect (Wii_Screenpos.x - cursor.width / 2, Wii_Screenpos.y - cursor.height / 2, cursor.width, cursor.height), cursor);
		}
		
	}
				
	void DrawShadowText (Rect pos, string text)
	{
		GUI.color = Color.black;
		GUI.Label (new Rect (pos.x + 1, pos.y + 1, pos.width, pos.height), text, nullstyle);
		GUI.color = Color.white;
		GUI.Label (pos, text, nullstyle);
	}
	
	public void shot ()
	{
		Shot = true;
		Invoke ("stopShot", 0.05f);
		
	}
	
	void stopShot ()
	{
		Shot = false;	
	}
	
	void CleanUp ()
	{
		
		while (GameObject.Find("GameOver(Clone)") != null) {
			DestroyObject (GameObject.Find ("GameOver(Clone)"));
			DestroyImmediate (GameObject.Find ("GameOver(Clone)"));
			Destroy (GameObject.Find ("GameOver(Clone)"));
		}
		
		while (GameObject.Find("coin(Clone)") != null) {
			DestroyObject (GameObject.Find ("coin(Clone)"));
			DestroyImmediate (GameObject.Find ("coin(Clone)"));
			Destroy (GameObject.Find ("coin(Clone)"));
		}
		
		while (GameObject.Find("brickwall(Clone)") != null) {
			DestroyObject (GameObject.Find ("brickwall(Clone)"));
			DestroyImmediate (GameObject.Find ("brickwall(Clone)"));
			Destroy (GameObject.Find ("brickwall(Clone)"));
		}
		
		while (GameObject.Find("RING(Clone)") != null) {
			DestroyObject (GameObject.Find ("RING(Clone)"));
			DestroyImmediate (GameObject.Find ("RING(Clone)"));
			Destroy (GameObject.Find ("RING(Clone)"));
		}


		
		
		
	}
				
	void StartGame ()
	{
		Music.SP.StartMusic();
		gameState = GameState.game;
		Instantiate (paperPlane, planeSpawnpoint.position, Quaternion.Euler (270, 270, 0));
					
	}
			
	Rect DrawCenter (int height, Texture2D img)
	{
		return new Rect ((Screen.width / 2) - (img.width / 2), height, img.width, img.height);
	}
	
	// Update is called once per frame
	void Update ()
	{
		if (ThinkGearController.SP.connected)
			attention = ThinkGearController.SP.GetDataValue (ThinkGear.DATA_ATTENTION) / 100;
	
	}
}
