using UnityEngine;
using System;
using System.Collections;
using System.Runtime.InteropServices;
 
public class UniWiiCheck : MonoBehaviour {

	#region
	[DllImport ("UniWii")]
	private static extern void wiimote_start();
 
	[DllImport ("UniWii")]
	private static extern void wiimote_stop();
 
	[DllImport ("UniWii")]
	private static extern int wiimote_count();
	
//	[DllImport ("UniWii")]
//	private static extern byte wiimote_getAccX(int which);
//	[DllImport ("UniWii")]
//	private static extern byte wiimote_getAccY(int which);
//	[DllImport ("UniWii")]
//	private static extern byte wiimote_getAccZ(int which);

	[DllImport ("UniWii")]
	private static extern float wiimote_getIrX(int which);
	[DllImport ("UniWii")]
	private static extern float wiimote_getIrY(int which);
//	[DllImport ("UniWii")]
//	private static extern float wiimote_getRoll(int which);
	[DllImport ("UniWii")]
	private static extern float wiimote_getPitch(int which);
//	[DllImport ("UniWii")]
//	private static extern float wiimote_getYaw(int which);

	[DllImport ("UniWii")]
	private static extern bool wiimote_getButtonA(int which);
//	[DllImport ("UniWii")]
//	private static extern bool wiimote_getButtonB(int which);
	[DllImport ("UniWii")]
	private static extern bool wiimote_getButtonUp(int which);
//	[DllImport ("UniWii")]
//	private static extern bool wiimote_getButtonLeft(int which);
//	[DllImport ("UniWii")]
//	private static extern bool wiimote_getButtonRight(int which);
	[DllImport ("UniWii")]
	private static extern bool wiimote_getButtonDown(int which);
//	[DllImport ("UniWii")]
//	private static extern bool wiimote_getButton1(int which);
//	[DllImport ("UniWii")]
//	private static extern bool wiimote_getButton2(int which);
//	[DllImport ("UniWii")]
//	private static extern bool wiimote_getButtonPlus(int which);
//	[DllImport ("UniWii")]
//	private static extern bool wiimote_getButtonMinus(int which);
//	[DllImport ("UniWii")]
//	private static extern bool wiimote_getButtonHome(int which);
	#endregion
 
	public static UniWiiCheck SP;
	private String display;
 	int c;
	bool connected;
	float updateRate = 0.1f;
	float moveSpeed =10;
	bool pressedA = false;
	bool pressedUp = false;
	bool pressedDown = false;
	float ir_x =-100;
	float ir_y = -100;
	
	public float pitch = 0;


	
	void FixedUpdate ()
	{
		if(connected)
		{
			if ( (ir_x != -100) && (ir_y != -100) ) 
			{
			    	float temp_x = ((ir_x + 1.0f)/ 2.0f) * Screen.width;
			    	float temp_y = Screen.height - (((ir_y + 1.0f)/ 2.0f) * Screen.height);
/*			    	float temp_x = ( Screen.width * 0.5f) + ir_x * Screen.width * 0.5f;
			    	float temp_y = Screen.height - (ir_y * Screen.height * 0.5f);*/
			    	Menu.SP.Wii_Screenpos.x = Mathf.Lerp(Menu.SP.Wii_Screenpos.x,temp_x,Time.deltaTime*moveSpeed);
			    	Menu.SP.Wii_Screenpos.y =  Mathf.Lerp(Menu.SP.Wii_Screenpos.y,temp_y,Time.deltaTime*moveSpeed);
			}
		}
	}
	
	public bool wiiButton_A()
	{
		return pressedA;
	}
	
	public bool wiiButton_Up()
	{
		return pressedUp;
	}
	
	public bool wiiButton_Down()
	{
		return pressedDown;
	}
	

 
	void Start ()
	{
		SP = this;
		Debug.Log("Starting WiiMote");

		wiimote_start();
		Invoke("CheckConnection",1);
	}
	
	void updateData()
	{
		pitch = wiimote_getPitch(0);
		if(!Menu.SP.WiiMove)
		{
		pressedA = wiimote_getButtonA(0);
		ir_x = wiimote_getIrX(0);
		ir_y = wiimote_getIrY(0);	
		}
		
	}
	
	void CheckConnection()
	{
		c = wiimote_count();
		Debug.Log("Checking WiiMote connection");
		if (c>0) 
			{
					InvokeRepeating("updateData",0,updateRate);
			Debug.Log("Connected WiiMote");
			connected = true;
			Menu.SP.wiiMoteConnection = true;
			}
	}
	
 
	void OnApplicationQuit() {
		wiimote_stop();
	}
 
}