using UnityEngine;
using System.Collections;

public class copter2 : MonoBehaviour
{
	
	float attention = 0;
	public float speed = 0.1f;
	bool started = false;
	float power = 1;
	bool recharged = true;
	Transform bullet;
	public AudioClip coin;
	public AudioClip checkpoint;
	public AudioClip death;
	public AudioClip gunShot;
	public AudioClip reload;
	public AudioClip breakstone;
	public Transform GameOver;
	RaycastHit hite;
	bool powerUp = false;
	int timer = 0;
	float oldAtten= 0;
	
	// Use this for initialization
	void Start ()
	{
		animation.Play ();
		Invoke ("CountDown", 0.5f);
	}
	
	// Update is called once per frame
	void Update ()
	{
		

		
		if (started) { 
			
			if (Input.GetKeyDown (KeyCode.F12))
				EndGame ();
			
			if (timer == 30) {
				Menu.SP.score += 1;	
				timer = 0;
			}
			timer++;
			if (ThinkGearController.SP.connected && !Menu.SP.WiiMove) {
				attention = Menu.SP.attention;
				MoveMind ();
			} else if(Menu.SP.WiiMove == true && Menu.SP.wiiMoteConnection)
			{
				MoveWii();
				attention = Mathf.Lerp (attention, Menu.SP.attention, Time.deltaTime * 2);
				Time.timeScale = 1+ attention*2;
						Music.SP.SetPitch(1+ attention/10);
			}
			else
				MoveKeyboard ();
			
		}
		

	}
	
	void CountDown ()
	{
		Countdown.SP.CountdownAnimation ();
		Invoke ("StartFlying", 2.5f);
	}
	
	void StartFlying ()
	{
		started = true;	
		audio.Play();
		Music.SP.StartMusic();
		ObjectSpawner.SP.StartSpawning ();
	}
	
	void MoveWii()
	{
	//	transform.position += new Vector3(0,Mathf.Clamp((-UniWiiCheck.SP.pitch/90),-1,1),0);
		transform.rigidbody.AddForce (new Vector3(0,Mathf.Clamp((-UniWiiCheck.SP.pitch/60)*0.1f,-1,1),0), ForceMode.VelocityChange);
		transform.rotation = Quaternion.LookRotation (new Vector3 (-rigidbody.velocity.y, 10, 0), Vector3.right);
	}

	void MoveMind ()
	{
	
	//transform.rigidbody.AddForce (new Vector3 (0, (attention-oldAtten)*10, 0), ForceMode.VelocityChange);
		
		transform.rigidbody.AddForce (new Vector3 (0, attention * 0.9f * speed, 0), ForceMode.Force);
		transform.rigidbody.AddForce (new Vector3 (0, -0.5f * speed, 0), ForceMode.Force);
	//	oldAtten = attention;
		
		transform.rotation = Quaternion.LookRotation (new Vector3 (-rigidbody.velocity.y, 10, 0), Vector3.right);
		
		if (UniWiiCheck.SP.wiiButton_A () && recharged && Menu.SP.bullets > 0) {
			Menu.SP.bullets --;
			Ray ray = Camera.main.ScreenPointToRay (new Vector2 (Menu.SP.Wii_Screenpos.x + 12, Screen.height - Menu.SP.Wii_Screenpos.y + 25));
			recharged = false;
			Invoke ("Recharge", 0.65f);
			Menu.SP.shot ();

			audio.PlayOneShot (gunShot);
			if (Physics.Raycast (ray, out hite, 10000f)) {
				if (hite.transform.tag == "coin") {
					Destroy (hite.transform.gameObject);
					audio.PlayOneShot (coin);
				}
				
				if (hite.transform.tag == "brick") {
					audio.PlayOneShot (breakstone);
					Destroy (hite.transform.gameObject);
				}
	


			}

		}
	}
	
	void Recharge ()
	{
		recharged = true;	
	}

	void OnTriggerEnter (Collider other)
	{

		if (other.transform.tag == "coin") {
			audio.PlayOneShot (coin);
			Menu.SP.score += 50;
			Destroy (other.gameObject);
			
		}
		
		if (other.transform.tag == "ring") {
			other.transform.tag = "Untagged";
			audio.PlayOneShot (checkpoint);
			Menu.SP.score += 100;
			
		}
		
		if (other.transform.tag == "bullets") {
			audio.PlayOneShot (reload);
			Menu.SP.bullets += 3;
			Destroy (other.gameObject);
			
		}
		
		

		if (other.transform.tag == "brick") {
			EndGame ();

			
		}
	}
	
	void EndGame ()
	{
		Menu.SP.WiiMove = false;
		Time.timeScale = 1;
		Music.SP.SetPitch(1);
		Music.SP.StopMusic();
		Instantiate (GameOver, new Vector3 (10, 10, -13), Quaternion.Euler (90, 180, 0));
		audio.PlayOneShot (death);
		Invoke ("ShowScore", 1);
		//other.transform.tag = "Untagged";

		rigidbody.useGravity = true;
		rigidbody.freezeRotation = false;
		started = false;
		ObjectSpawner.SP.StopSpawning ();	
	}
				
	void ShowScore ()
	{
		audio.Stop ();
		Menu.SP.gameState = Menu.GameState.gameOver;
		Invoke ("SelfDestruct", 1);
	}
	
	void SelfDestruct ()
	{
		Destroy (gameObject);
	}
	
	void MoveKeyboard ()
	{
		if (Input.anyKey)
			transform.rigidbody.AddForce (new Vector3 (0, (1 - 0.5f) * speed, 0), ForceMode.Force);
		else
			transform.rigidbody.AddForce (new Vector3 (0, (-0.5f) * speed, 0), ForceMode.Force);	
		
		transform.rotation = Quaternion.LookRotation (new Vector3 (-rigidbody.velocity.y, 10, 0), Vector3.right);
	}
}
